# coding: utf-8

"""
    OurSky SDA

    The basic flow for a new organization is as follows: 1. View the available satellite targets with the [satellite targets](#tag/satellite-targets/[get]/v1/satellite-targets) endpoint. Copy the id of the target you want to observe. 2. Create an organization target with the [organization target](#tag/organization-targets/[get]/v1/organization-targets) endpoint. Use the id copied from above. 3. Create a webhook with the [webhook](#tag/webhooks/[post]/v1/communications/webhook) endpoint to receive TDMs automatically (preferred) or use the [tdms](#tag/tdms/[get]/v1/tdms) endpoint to poll for TDMs.

    The version of the OpenAPI document: 1.3.3724
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import json
import pprint
import re  # noqa: F401
from aenum import Enum, no_arg





class WebhookEvent(str, Enum):
    """
    Webhook events that can be subscribed to. For `EO_OBSERVATION` events, please refer to the Unified Data Library for the full schema.
    """

    """
    allowed enum values
    """
    V1_TDM_CREATED = 'V1_TDM_CREATED'
    V1_OBSERVATION_SEQUENCE_RESULT_CREATED = 'V1_OBSERVATION_SEQUENCE_RESULT_CREATED'
    V1_OBSERVATION_CREATED = 'V1_OBSERVATION_CREATED'
    V1_IMAGE_CREATED = 'V1_IMAGE_CREATED'
    V1_STREAK_CREATED = 'V1_STREAK_CREATED'
    V1_SATELLITE_TARGET_TRACKING_DEACTIVATED = 'V1_SATELLITE_TARGET_TRACKING_DEACTIVATED'
    V1_EO_OBSERVATION_CREATED = 'V1_EO_OBSERVATION_CREATED'

    @classmethod
    def from_json(cls, json_str: str) -> WebhookEvent:
        """Create an instance of WebhookEvent from a JSON string"""
        return WebhookEvent(json.loads(json_str))


